RDKit: RDCatalog::Catalog< entryType, paramType > Class Template Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Attributes | List of all members
RDCatalog::Catalog< entryType, paramType > Class Template Referenceabstract

abstract base class for a catalog object More...

`#include <Catalog.h>`

Inheritance diagram for RDCatalog::Catalog< entryType, paramType >:

## Public Types
typedef entryType | entryType_t
typedef paramType | paramType_t

## Public Member Functions
| Catalog ()
virtual | ~Catalog ()
virtual std::string | Serialize () const =0
| return a serialized form of the Catalog as an std::string
virtual unsigned int | addEntry (entryType *entry, bool updateFPLength=true)=0
| adds an entry to the catalog
virtual const entryType * | getEntryWithIdx (unsigned int idx) const =0
| returns a particular entry in the Catalog
virtual unsigned int | getNumEntries () const =0
| returns the number of entries
unsigned int | getFPLength () const
| returns the length of our fingerprint
void | setFPLength (unsigned int val)
| sets our fingerprint length
virtual void | setCatalogParams (const paramType *params)
| sets our parameters by copying the `params` argument
const paramType * | getCatalogParams () const
| returns a pointer to our parameters

## Protected Attributes
unsigned int | d_fpLength {0}
| the length of our fingerprint
paramType * | dp_cParams
| our params object

## Detailed Description

template<class entryType, class paramType>
class RDCatalog::Catalog< entryType, paramType >

abstract base class for a catalog object

Definition at line 40 of file Catalog.h.

## Member Typedef Documentation

## ◆ entryType_t

template<class entryType, class paramType>

typedef entryType RDCatalog::Catalog< entryType, paramType >::entryType_t

Definition at line 42 of file Catalog.h.

## ◆ paramType_t

template<class entryType, class paramType>

typedef paramType RDCatalog::Catalog< entryType, paramType >::paramType_t

Definition at line 43 of file Catalog.h.

## Constructor & Destructor Documentation

## ◆ Catalog()

template<class entryType, class paramType>

RDCatalog::Catalog< entryType, paramType >::Catalog | ( |  | ) |
| inline

Definition at line 46 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::HierarchCatalog().

## ◆ ~Catalog()

template<class entryType, class paramType>

virtual RDCatalog::Catalog< entryType, paramType >::~Catalog | ( |  | ) |
| inlinevirtual

Definition at line 49 of file Catalog.h.

## Member Function Documentation

## ◆ addEntry()

template<class entryType, class paramType>

virtual unsigned int RDCatalog::Catalog< entryType, paramType >::addEntry | ( | entryType * | entry,
|  | bool | updateFPLength = true )
| pure virtual

adds an entry to the catalog

Parameters

  entry | the entry to be added
  updateFPLength | (optional) if this is true, our internal fingerprint length will also be updated.

Implemented in RDCatalog::HierarchCatalog< entryType, paramType, orderType >.

## ◆ getCatalogParams()

template<class entryType, class paramType>

const paramType * RDCatalog::Catalog< entryType, paramType >::getCatalogParams | ( |  | ) | const
| inline

returns a pointer to our parameters

Definition at line 101 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::toStream().

## ◆ getEntryWithIdx()

template<class entryType, class paramType>

virtual const entryType * RDCatalog::Catalog< entryType, paramType >::getEntryWithIdx | ( | unsigned int | idx | ) | const
| pure virtual

returns a particular entry in the Catalog

Implemented in RDCatalog::HierarchCatalog< entryType, paramType, orderType >, RDCatalog::HierarchCatalog< AcidBaseCatalogEntry, AcidBaseCatalogParams, int >, RDCatalog::HierarchCatalog< AcidBaseCatalogEntry, AcidBaseCatalogParams, int >, RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >, RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >, RDCatalog::HierarchCatalog< FragmentCatalogEntry, FragmentCatalogParams, int >, RDCatalog::HierarchCatalog< FragmentCatalogEntry, FragmentCatalogParams, int >, RDCatalog::HierarchCatalog< MolCatalogEntry, MolCatalogParams, int >, RDCatalog::HierarchCatalog< MolCatalogEntry, MolCatalogParams, int >, RDCatalog::HierarchCatalog< TautomerCatalogEntry, TautomerCatalogParams, int >, RDCatalog::HierarchCatalog< TautomerCatalogEntry, TautomerCatalogParams, int >, RDCatalog::HierarchCatalog< TransformCatalogEntry, TransformCatalogParams, int >, RDCatalog::HierarchCatalog< TransformCatalogEntry, TransformCatalogParams, int >, and RDKit::FilterCatalog.

## ◆ getFPLength()

template<class entryType, class paramType>

unsigned int RDCatalog::Catalog< entryType, paramType >::getFPLength | ( |  | ) | const
| inline

returns the length of our fingerprint

Definition at line 77 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::addEntry(), RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::getEntryWithBitId(), RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::getIdOfEntryWithBitId(), and RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::toStream().

## ◆ getNumEntries()

template<class entryType, class paramType>

virtual unsigned int RDCatalog::Catalog< entryType, paramType >::getNumEntries | ( |  | ) | const
| pure virtual

returns the number of entries

Implemented in RDCatalog::HierarchCatalog< entryType, paramType, orderType >, RDCatalog::HierarchCatalog< AcidBaseCatalogEntry, AcidBaseCatalogParams, int >, RDCatalog::HierarchCatalog< AcidBaseCatalogEntry, AcidBaseCatalogParams, int >, RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >, RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >, RDCatalog::HierarchCatalog< FragmentCatalogEntry, FragmentCatalogParams, int >, RDCatalog::HierarchCatalog< FragmentCatalogEntry, FragmentCatalogParams, int >, RDCatalog::HierarchCatalog< MolCatalogEntry, MolCatalogParams, int >, RDCatalog::HierarchCatalog< MolCatalogEntry, MolCatalogParams, int >, RDCatalog::HierarchCatalog< TautomerCatalogEntry, TautomerCatalogParams, int >, RDCatalog::HierarchCatalog< TautomerCatalogEntry, TautomerCatalogParams, int >, RDCatalog::HierarchCatalog< TransformCatalogEntry, TransformCatalogParams, int >, RDCatalog::HierarchCatalog< TransformCatalogEntry, TransformCatalogParams, int >, and RDKit::FilterCatalog.

## ◆ Serialize()

template<class entryType, class paramType>

virtual std::string RDCatalog::Catalog< entryType, paramType >::Serialize | ( |  | ) | const
| pure virtual

return a serialized form of the Catalog as an std::string

Implemented in RDCatalog::HierarchCatalog< entryType, paramType, orderType >, RDCatalog::HierarchCatalog< AcidBaseCatalogEntry, AcidBaseCatalogParams, int >, RDCatalog::HierarchCatalog< AcidBaseCatalogEntry, AcidBaseCatalogParams, int >, RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >, RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >, RDCatalog::HierarchCatalog< FragmentCatalogEntry, FragmentCatalogParams, int >, RDCatalog::HierarchCatalog< FragmentCatalogEntry, FragmentCatalogParams, int >, RDCatalog::HierarchCatalog< MolCatalogEntry, MolCatalogParams, int >, RDCatalog::HierarchCatalog< MolCatalogEntry, MolCatalogParams, int >, RDCatalog::HierarchCatalog< TautomerCatalogEntry, TautomerCatalogParams, int >, RDCatalog::HierarchCatalog< TautomerCatalogEntry, TautomerCatalogParams, int >, RDCatalog::HierarchCatalog< TransformCatalogEntry, TransformCatalogParams, int >, RDCatalog::HierarchCatalog< TransformCatalogEntry, TransformCatalogParams, int >, and RDKit::FilterCatalog.

## ◆ setCatalogParams()

template<class entryType, class paramType>

virtual void RDCatalog::Catalog< entryType, paramType >::setCatalogParams | ( | const paramType * | params | ) |
| inlinevirtual

sets our parameters by copying the `params` argument

Definition at line 85 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::HierarchCatalog(), and RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::initFromStream().

## ◆ setFPLength()

template<class entryType, class paramType>

void RDCatalog::Catalog< entryType, paramType >::setFPLength | ( | unsigned int | val | ) |
| inline

sets our fingerprint length

Definition at line 81 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::addEntry(), and RDCatalog::HierarchCatalog< FragCatalogEntry, FragCatParams, int >::initFromStream().

## Member Data Documentation

## ◆ d_fpLength

template<class entryType, class paramType>

unsigned int RDCatalog::Catalog< entryType, paramType >::d_fpLength {0}
| protected

the length of our fingerprint

Definition at line 109 of file Catalog.h.

## ◆ dp_cParams

template<class entryType, class paramType>

paramType* RDCatalog::Catalog< entryType, paramType >::dp_cParams
| protected

our params object

Definition at line 110 of file Catalog.h.

The documentation for this class was generated from the following file:

- Catalog.h